Index: Singular/LIB/tropical.lib
===================================================================
--- Singular/LIB/tropical.lib	(revision fba86f89b3458187b40c5f0d5f6408412d98d295)
+++ Singular/LIB/tropical.lib	(revision 7d56875cf7720719f5b6acd193768a4d5b57848f)
@@ -4598,16 +4598,16 @@
 /// - eliminatecomponents
 /// - findzerosAndBasictransform
-/// - ordermaximalideals 
+/// - ordermaximalideals
 ////////////////////////////////////////////////////////////////////////////////////
 
 static proc tropicalparametrise (ideal i,intvec ww,int ordnung,int gfanold,int findall,int nogfan,list #)
 "USAGE:  tropicalparametrise(i,tw,ord,gf,fa,ng[,#]); i ideal, tw intvec, ord int, gf,fa,ng int, # opt. list
-ASSUME:  - i is an ideal in Q[t,x_1,...,x_n,@a], tw=(w_0,w_1,...,w_n,0) 
-           and (w_0,...,w_n,0) is in the tropical variety of i, 
-           and ord is the order up to which a point in V(i) over K{{t}} lying over w shall be computed; 
+ASSUME:  - i is an ideal in Q[t,x_1,...,x_n,@a], tw=(w_0,w_1,...,w_n,0)
+           and (w_0,...,w_n,0) is in the tropical variety of i,
+           and ord is the order up to which a point in V(i) over K{{t}} lying over w shall be computed;
          - moreover, @a should be not be there if the procedure is not called recursively;
          - the point in the tropical variety is supposed to lie in the NEGATIVE orthant;
          - the ideal is zero-dimensional when considered in (K(t)[@a]/m)[x_1,...,x_n],
-           where m=#[2] is a maximal ideal in K[@a]; 
+           where m=#[2] is a maximal ideal in K[@a];
          - gf is 0 if version 2.2 or larger is used and it is 1 else
          - fa is 1 if all solutions should be found
@@ -4616,5 +4616,5 @@
                l[2] = int
 NOTE:    - the procedure is also called recursively by itself, and
-           if it is called in the first recursion, the list # is empty, 
+           if it is called in the first recursion, the list # is empty,
            otherwise #[1] is an integer, one more than the number of true variables x_1,...,x_n,
            and #[2] will contain the maximal ideal m in the variable @a
@@ -4651,5 +4651,5 @@
     int anzahlvariablen=nvars(basering);
     list zerolist; // will carry the zeros which are computed in the recursion steps
-    
+
     // the initial ideal of i has been handed over as #[1]
     ideal ini=#[1];
@@ -4660,5 +4660,5 @@
   }
   list wneulist; // carries all newly computed weight vector
-  intvec wneu;   // carries the newly computed weight vector 
+  intvec wneu;   // carries the newly computed weight vector
   int tweight;   // carries the weight of t
   list PARALIST; // carries the result when tropicalparametrise is recursively called
@@ -4695,16 +4695,16 @@
       {
         if (nogfan!=1)
-        {          
+        {
           // pass to a ring which has variables which are suitable for gfan
           execute("ring GFANRING=("+string(char(basering))+"),(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z),dp;");
-          ideal phiideal=b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z; 
+          ideal phiideal=b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z;
           phiideal[nvars(PREGFANRING)]=a; // map t to a
-          map phi=PREGFANRING,phiideal; 
+          map phi=PREGFANRING,phiideal;
           ideal II=phi(i);
-          // homogenise the ideal II with the first not yet used variable in our ring, since gfan 
+          // homogenise the ideal II with the first not yet used variable in our ring, since gfan
           // only handles homogenous ideals; in principle for this one has first to compute a
-          // standard basis of II and homogenise that, but for the tropical variety (says Anders) 
+          // standard basis of II and homogenise that, but for the tropical variety (says Anders)
           // it suffices to homogenise an arbitrary system of generators
-          // II=groebner(II); 
+          // II=groebner(II);
           II=homog(II,maxideal(1)[nvars(PREGFANRING)+1]);
           // if gfan version >= 0.3.0 is used and the characteristic
@@ -4751,5 +4751,5 @@
             ~
             // THIS IS NOT NECESSARY !!!! IF WE COMPUTE NOT ONLY THE TROPICAL PREVARIETY
-            // test, if wneu really is in the tropical variety    
+            // test, if wneu really is in the tropical variety
             while (goon==0)
             {
@@ -4796,5 +4796,5 @@
       lll=0;
       if ((ordnung>1) and (anzahlvariablen>1))
-      { 
+      {
         partliftings=list(); // initialise partliftings
         // we call the procedure with the transformed ideal i, the new weight vector, with the
@@ -4808,9 +4808,9 @@
           // the maximal ideal that describes the necessary field extension
           for (ll=1;ll<=size(PARALIST);ll++)
-          {  
+          {
             def PARARing=PARALIST[ll][1];
             tweight=-ww[1]*PARALIST[ll][2];
             setring PARARing;
-            // if some variables have been eliminated in before, then we have to insert zeros 
+            // if some variables have been eliminated in before, then we have to insert zeros
             // into the parametrisation for those variables
             if (numberdeletedvariables>0)
@@ -4844,5 +4844,5 @@
         tweight=-ww[1];
         // if additional variables were necessary, we introduce them now as parameters;
-        // in any case the parametrisation ring will have only one variable, namely t,  
+        // in any case the parametrisation ring will have only one variable, namely t,
         // and its order will be local, so that it displays the lowest term in t first
         if (anzahlvariablen<nvars(basering))
@@ -4872,5 +4872,5 @@
       {
         if (size(partliftings[lll])==2) // when tropicalparametrise is called for the last time, it does not
-        {                     // enter the part, where wneu is defined and the variable t should have 
+        {                     // enter the part, where wneu is defined and the variable t should have
           wneu=-1;     // weight -1
         }
@@ -4904,5 +4904,5 @@
   }
   // kill the gfan files in /tmp
-  system("sh","cd /tmp; /bin/rm gfaninput; /bin/rm gfanoutput");  
+  system("sh","cd /tmp; /bin/rm gfaninput; /bin/rm gfanoutput");
   // we return a list which contains lists of the parametrisation rings (with the parametrisation ideal)
   // and an integer N such that t should be replaced by t^1/N
@@ -4912,7 +4912,7 @@
 static proc eliminatecomponents (ideal i,ideal m,int anzahlvariablen,int findall,int lastvar,intvec deletedvariables)
 "USAGE:  eliminatecomponents(i,m,n,a,v,d); i,m ideal, n,a,v int, d intvec
-ASSUME:  i is an ideal in Q[x_1,...,x_n,@a,t] and w=(-w_1/w_0,...,-w_n/w_0) 
-         is in the tropical variety of i considered in Q[@a]/m{{t}}[x_1,...,x_n]; 
-         considered in this ring i is zero-dimensional; @a need not be present 
+ASSUME:  i is an ideal in Q[x_1,...,x_n,@a,t] and w=(-w_1/w_0,...,-w_n/w_0)
+         is in the tropical variety of i considered in Q[@a]/m{{t}}[x_1,...,x_n];
+         considered in this ring i is zero-dimensional; @a need not be present
          in which case m is zero; 1<=v<=n
 RETURN:  list, L of lists
@@ -4922,5 +4922,5 @@
 NOTE:    - the procedure is called from inside the recursive procedure tropicalparametrise
          - the procedure checks for solutions which have certain components zero; these are
-           separated from the rest by elimination and saturation; the integer deletedvariables 
+           separated from the rest by elimination and saturation; the integer deletedvariables
            records which variables have been eliminated; the integer anzahlvariablen records how
            many true variables remain after the elimination
@@ -4933,14 +4933,14 @@
   // if all solutions have to be found
   if (findall==1)
-  {    
+  {
     list saturatelist,eliminatelist; // carry the solution of the two tests
-    // we test first if there is a solution which has the component lastvar zero and 
+    // we test first if there is a solution which has the component lastvar zero and
     // where the order of each component is strictly positive;
     // if so, we add this variable to the ideal and eliminate it - which amounts to
     // to projecting the solutions with this component zero to the hyperplane without this component;
     // for the test we compute the saturation with respect to t and replace each variable
-    // x_i and also t by zero -- if the result is zero, then 1 is not in I:t^infty 
+    // x_i and also t by zero -- if the result is zero, then 1 is not in I:t^infty
     // (i.e. there is a solution which has the component lastvar zero) and
-    // the result lives in the maximal ideal <t,x_1,...,[no x_lastvar],...,x_n> so that 
+    // the result lives in the maximal ideal <t,x_1,...,[no x_lastvar],...,x_n> so that
     // there is a solution which has strictly positive valuation
 /*
@@ -4954,5 +4954,5 @@
     // equal to zero then this component has a valuation with all strictly positive values!!!!;
     // for this we can either saturate the ideal after elimination with respect to <t,x_1,...,x_n>
-    // and see if the saturated ideal is contained in <t,x_1,...x_n>+m, 
+    // and see if the saturated ideal is contained in <t,x_1,...x_n>+m,
     // or ALTERNATIVELY we can pass to the ring 0,(t,x_1,...,x_n,@a),(ds(n+1),dp(1)),
     // compute a standard basis of the elimination ideal (plus m) there and check if the dimension 1
@@ -4989,5 +4989,5 @@
       {
         string elring="ring ELIMINATERING=("+charstr(basering)+"),("+string(simplify(reduce(maxideal(1),std(var(lastvar))),2))+"),(";
-      }    
+      }
       if (anzahlvariablen<nvars(basering)) // if @a was present, the ordersting needs an additional entry
       {
@@ -4995,5 +4995,5 @@
       }
       elring=elring+"lp(1));";
-      execute(elring);      
+      execute(elring);
       ideal i=imap(BASERING,I); // move the ideal I to the new ring
       // if not yet all variables have been checked, then go on with the next smaller variable,
@@ -5011,10 +5011,10 @@
     }
     // next we have to test if there is also a solution which has the variable lastvar non-zero;
-    // to do so, we saturate with respect to this variable; since when considered over K{{t}} 
+    // to do so, we saturate with respect to this variable; since when considered over K{{t}}
     // the ideal is zero dimensional, this really removes  all solutions with that component zero;
     // the checking is then done as above
     i=std(sat(i,var(lastvar))[1]);
     I=reduce(i,std(m)); // "remove" m from i
-    // test first, if i still is in the ideal <t,x_1,...,x_n> -- if not, then 
+    // test first, if i still is in the ideal <t,x_1,...,x_n> -- if not, then
     // we know that i has no longer a point in the tropical variety with all components negative
     LI=subst(I,var(nvars(basering)),0);
@@ -5024,5 +5024,5 @@
     }
     if (size(LI)==0) // the entries of i have not constant part
-    {      
+    {
       // check now, if the leading ideal of i contains an element which only depends on t
       LI=lead(I);
@@ -5040,5 +5040,5 @@
         }
         else
-        {   
+        {
           execute("ring SATURATERING=("+charstr(basering)+"),("+varstr(basering)+"),("+ordstr(basering)+");");
           ideal i=imap(BASERING,i);
@@ -5069,5 +5069,5 @@
       if (size(LI)==0) // if no power of t is in lead(I) (where the X(i) are considered as field elements)
       {
-        // get rid of var(j)   
+        // get rid of var(j)
         i=eliminate(I,var(j));
         deletedvariables[j]=1;
@@ -5086,5 +5086,5 @@
     }
     // if there are variables left, then pass to a ring which only realises these variables
-    // else we are done 
+    // else we are done
     if (anzahlvariablen>1)
     {
@@ -5094,5 +5094,5 @@
     {
       string elring="ring ELIMINATERING=("+charstr(basering)+"),("+string(variablen)+"),(";
-    }    
+    }
     if (size(deletedvariables)+1<nvars(basering)) // if @a was present, the ordersting needs an additional entry
     {
@@ -5100,5 +5100,5 @@
     }
     elring=elring+"lp(1));";
-    execute(elring);      
+    execute(elring);
     ideal i=imap(BASERING,i);
     ideal m=imap(BASERING,m);
@@ -5111,5 +5111,5 @@
 static proc findzerosAndBasictransform (ideal i,intvec w,list zerolist,int findall,list #)
 "USAGE:      findzerosAndBasictransform(i,w,z,f[,#]); i ideal, w intvec, z list, f int,# an optional list
-ASSUME:      i is an ideal in Q[t,x_1,...,x_n,@a] and w=(w_0,...,w_n,0) 
+ASSUME:      i is an ideal in Q[t,x_1,...,x_n,@a] and w=(w_0,...,w_n,0)
              is in the tropical variety of i; @a need not be present;
              the list 'zero' contains the zeros computed in previous recursion steps;
@@ -5125,6 +5125,6 @@
                    list zero  = zero[k+1] is the kth component of a zero the t-initial ideal of i
 NOTE:     -  the procedure is called from inside the recursive procedure tropicalparametrise;
-             if it is called in the first recursion, the list #[1] contains the t-initial ideal 
-             of i w.r.t. w, otherwise #[1] is an integer, one more than the number of true 
+             if it is called in the first recursion, the list #[1] contains the t-initial ideal
+             of i w.r.t. w, otherwise #[1] is an integer, one more than the number of true
              variables x_1,...,x_n
           -  if #[2] is present, then it is an integer which tells whether ALL zeros should be
@@ -5154,9 +5154,9 @@
     int anzahlvariablen=nvars(basering);
     ideal ini=#[1]; // the t-initial ideal has been computed in before and was handed over
-  } 
+  }
   // collect the true variables x_1,...,x_n plus @a, if it is defined in BASERING
   ideal variablen;
   for (j=1;j<=nvars(basering)-1;j++)
-  {   
+  {
     variablen=variablen+var(j);
   }
@@ -5187,5 +5187,5 @@
       // phi maps x_i to x_i, @a to @a (if present in the ring), and the additional variable
       // for the field extension is mapped to @a as well -- note that we only apply phi
-      // to the list a, and in this list no @a is present; therefore, it does not matter 
+      // to the list a, and in this list no @a is present; therefore, it does not matter
       // where this is mapped to
       map phi=ABSRING,imap(BASERING,variablen),@a;
@@ -5197,8 +5197,8 @@
       // for the field extension is mapped to @a as well respectively to 0, if no @a is present;
       // note that we only apply phi to the list a and to the replacement rule for
-      // the old variable @a, and in this list resp. replacement rule no @a is present; 
+      // the old variable @a, and in this list resp. replacement rule no @a is present;
       // therefore, it does not matter where this is mapped to;
       if (anzahlvariablen<nvars(EXTENSIONRING)) // @a is in EXTENSIONRING
-      {      
+      {
         map phi=ABSRING,imap(BASERING,variablen),@a; // additional variable is mapped to @a
       }
@@ -5212,8 +5212,8 @@
     poly m=maximalideals[j][1];    // extract m
     list zeroneu=maximalideals[j][2]; // extract the new zero
-    poly repl=maximalideals[j][3]; // extract the replacement rule    
+    poly repl=maximalideals[j][3]; // extract the replacement rule
     // the list zero may very well exist as an EMPTY global list - in this case we have to remove it
     // in order to avoid a redefining warning
-    if (defined(zero)!=0) 
+    if (defined(zero)!=0)
     {
       if (size(zero)==0)
@@ -5227,13 +5227,13 @@
       ideal i=imap(BASERING,i);
       if (defined(zerolist)==0) // if zerolist is empty, it does not depend on BASERING !
-      {        
+      {
         list zero=imap(BASERING,zerolist);
       }
-      else 
+      else
       {
         list zero=zerolist;
       }
     }
-    else // in BASERING was @a present 
+    else // in BASERING was @a present
     {
       ideal variablen=imap(BASERING,variablen);
@@ -5247,10 +5247,10 @@
     zero[size(zero)+1]=zeroneu;
     // do now the basic transformation sending x_l -> t^-w_l*(zero_l+x_l)
-    for (l=1;l<=anzahlvariablen;l++)  
+    for (l=1;l<=anzahlvariablen;l++)
     {
       for (k=1;k<=size(i);k++)
       {
         if (l!=1) // corresponds to  x_(l-1) --  note t is the last variable
-        {        
+        {
           i[k]=substitute(i[k],var(l-1),(zeroneu[l]+var(l-1))*t^(-w[l]));
         }
@@ -5265,5 +5265,5 @@
     {
       if (wdegs[l]<0) // if wdegs[l]==0 there is no need to divide, and we made sure that it is no positive
-      {      
+      {
         i[l]=i[l]/t^(-wdegs[l]);
       }
@@ -5276,5 +5276,5 @@
     export(i);
     export(m);
-    export(zero);    
+    export(zero);
     extensionringlist[j]=EXTENSIONRING;
     kill EXTENSIONRING;
@@ -5290,10 +5290,10 @@
              polynomial of the last variable in the ring which is considered as a parameter
 RETURN:      list, the procedure orders the maximal ideals in minassi according to how many new
-                   variables are needed (namely none or one) to describe the zeros of the ideal, 
+                   variables are needed (namely none or one) to describe the zeros of the ideal,
                    and accordingly to the degree of the corresponding minimal polynomial
                    l[j][1] = the minimal polynomial for the jth maximal ideal
-                   l[j][2] = list, the k+1st entry is the kth coordinate of the zero 
+                   l[j][2] = list, the k+1st entry is the kth coordinate of the zero
                                    described by the maximal ideal in terms of the last variable
-                   l[j][3] = poly, the replacement for the old variable @a 
+                   l[j][3] = poly, the replacement for the old variable @a
 NOTE:        if a maximal ideal contains a variable, it is removed from the list;
              the procedure is called by findzerosAndBasictransform"
@@ -5306,9 +5306,9 @@
   list zero;         // (a_1,...,a_n)=(zero[2],...,zero[n+1]) will be a common zero of the ideal m
   poly nf;           // normalform of a variable w.r.t. m
-  poly minimalpolynomial;  // minimal polynomial for the field extension 
+  poly minimalpolynomial;  // minimal polynomial for the field extension
   poly parrep;       // the old variable @a possibly has to be replaced by a new one
   // compute for each maximal ideal the number of new variables, which are needed to describe
   // its zeros -- note, a new variable is needed if the first entry of minassi[j][1] is not the last variable
-  // store the value a variable reduces to in the list a; 
+  // store the value a variable reduces to in the list a;
   for (j=size(minassi);j>=1;j--)
   {
@@ -5337,5 +5337,5 @@
     // if the maximal ideal contains a variable, we simply delete it
     if (pruefer==0)
-    {      
+    {
       minassisort[j]=list(minimalpolynomial,zero,parrep);
     }
@@ -5354,5 +5354,5 @@
     l=j;
     for (k=j-1;k>=1;k--)
-    {      
+    {
       if (deg(minassisort[l][1])<deg(minassisort[k][1]))
       {
@@ -5393,11 +5393,11 @@
                    l[i][2] = y-coordinate of the ith vertex
                    l[i][3] = a polynomial whose monimials mark the vertices in the Newton polygon
-                             corresponding to the entries in tp which take the common minimum 
+                             corresponding to the entries in tp which take the common minimum
                              at the ith vertex
-NOTE:      - the information in l[i][3] represents the subdivision of the Newton polygon of tp 
-             (respectively a polynomial which defines tp); 
-           - if # is non-empty and #[1] is the string 'max', then in the computations minimum and 
-             maximum are exchanged; 
-           - if # is non-empty and the #[1] is not a string, only the vertices will be computed 
+NOTE:      - the information in l[i][3] represents the subdivision of the Newton polygon of tp
+             (respectively a polynomial which defines tp);
+           - if # is non-empty and #[1] is the string 'max', then in the computations minimum and
+             maximum are exchanged;
+           - if # is non-empty and the #[1] is not a string, only the vertices will be computed
              and the information on the Newton subdivision will be omitted;
            - here the tropical polynomial is supposed to be the MINIMUM of the linear forms in tp,
@@ -5406,5 +5406,5 @@
 {
   // if you insert a single polynomial instead of an ideal representing a tropicalised polynomial,
-  // then we compute first the tropicalisation of this polynomial -- this feature is not 
+  // then we compute first the tropicalisation of this polynomial -- this feature is not
   // documented in the above help string
   if (typeof(tp)=="poly")
@@ -5485,5 +5485,5 @@
             e++;
           }
-        }          
+        }
       }
     }
@@ -5511,16 +5511,16 @@
 RETURN:      list, see the procedure tropicalCurve for an explanation of the syntax of this list
 NOTE:      - the tropical curve defined by tp will consist of a bunch of parallel lines and
-             throughout the procedure a list with the name bunchoflines is computed, which 
+             throughout the procedure a list with the name bunchoflines is computed, which
              represents these lines and has the following interpretation:
              list, each entry corresponds to a vertex in the tropical plane curve defined by tp
                    l[i][1] = the equation of the ith line in the tropical curve
                    l[i][2] = a polynomial whose monimials mark the vertices in the Newton polygon
-                             corresponding to the entries in tp which take the common minimum 
+                             corresponding to the entries in tp which take the common minimum
                              at the ith vertex
-           - the information in l[i][2] represents the subdivision of the Newton polygon of tp 
-             (respectively a polynomial which defines tp); 
-           - if # is non-empty and #[1] is the string 'max', then in the computations minimum and 
-             maximum are exchanged; 
-           - if # is non-empty and the #[1] is not a string, only the vertices will be computed 
+           - the information in l[i][2] represents the subdivision of the Newton polygon of tp
+             (respectively a polynomial which defines tp);
+           - if # is non-empty and #[1] is the string 'max', then in the computations minimum and
+             maximum are exchanged;
+           - if # is non-empty and the #[1] is not a string, only the vertices will be computed
              and the information on the Newton subdivision will be omitted;
            - here the tropical polynomial is supposed to be the MINIMUM of the linear forms in tp,
@@ -5571,5 +5571,5 @@
       {
         vergleich=substitute(tp[l],var(1),px);
-        if (vergleich==wert)  
+        if (vergleich==wert)
         {
           newton=newton+detropicalise(oldtp[l]);
@@ -5582,5 +5582,5 @@
         e++;
       }
-    }          
+    }
   }
   // if a vertex appears several times, only its first occurence will be kept
@@ -5589,5 +5589,5 @@
     for (j=i-1;j>=1;j--)
     {
-      if (bunchoflines[i][1]==bunchoflines[j][1]) 
+      if (bunchoflines[i][1]==bunchoflines[j][1])
       {
         bunchoflines=delete(bunchoflines,i);
@@ -5630,5 +5630,5 @@
     xc=substitute(bunchoflines[i][1]-cc,var(2),0,var(1),1);
     yc=substitute(bunchoflines[i][1]-cc,var(2),1,var(1),0);
-	if (xc!=0) // then there is a point on the line with y-coordinate zero
+        if (xc!=0) // then there is a point on the line with y-coordinate zero
     {
       gr[1]=-cc/leadcoef(xc);
@@ -5650,9 +5650,9 @@
 
 static proc clearintmat (intmat vv)
-"USAGE:      clearintmat(vv); vv intmat 
+"USAGE:      clearintmat(vv); vv intmat
 ASSUME:      all entries of the first column of vv are non-negative, not all entries are zero
              unless vv has only one column
-RETURN:      intmat, vv has been ordered in an ascending way by the entries of the first row; 
-                     if an entry in the first row occurs several times, the entries in the 
+RETURN:      intmat, vv has been ordered in an ascending way by the entries of the first row;
+                     if an entry in the first row occurs several times, the entries in the
                      second row have been added and only one row has been kept;
                      colums with a zero in the first row have been removed unless vv has only one
@@ -5663,5 +5663,5 @@
   for (int i=ncols(vv)-1;i>=1;i--)
   {
-    if (vv[1,i]==vv[1,i+1]) 
+    if (vv[1,i]==vv[1,i+1])
     {
       vv[2,i]=vv[2,i]+vv[2,i+1];
@@ -5693,5 +5693,5 @@
         k++;
       }
-      else 
+      else
       {
         stop=1;
@@ -5768,5 +5768,5 @@
   {
     int m=nrows(M);
-    
+
   }
   else
@@ -5890,13 +5890,13 @@
     return(c);
   }
-  f=f-c;  
+  f=f-c;
   if (k==1)
   {
     return(substitute(f,var(1),1,var(2),0));
-  }    
+  }
   else
   {
     return(substitute(f,var(1),0,var(2),1));
-  }    
+  }
 }
 
@@ -5983,5 +5983,5 @@
 ASSUME:      f is a polynomial in Q[x_1,...,x_n], and # is either empty or #[1] is a positive integer
 RETURN:      string, a decimal expansion of the leading coefficient of f up to order two respectively #[1]
-NOTE:        the procedure is called by texDrawTropical and conicWithTangents and 
+NOTE:        the procedure is called by texDrawTropical and conicWithTangents and
              f will actually be a number"
 {
@@ -6010,5 +6010,5 @@
       }
       for (j=i;j<=i+nachkomma;j++)
-      {        
+      {
         news=news+s[j];
       }
@@ -6040,5 +6040,5 @@
   }
   return(0);
-}      
+}
 
 static proc stringdelete (string w,int i)
@@ -6054,5 +6054,5 @@
   {
     return("");
-    
+
   }
   if (i==1)
@@ -6109,5 +6109,5 @@
       k=j+2;
       while (k<=size(F) and ((F[k]=="0") or (F[k]=="1") or (F[k]=="2") or (F[k]=="3") or
-                                (F[k]=="4") or (F[k]=="5") or (F[k]=="6") or (F[k]=="7") or (F[k]=="8") 
+                                (F[k]=="4") or (F[k]=="5") or (F[k]=="6") or (F[k]=="7") or (F[k]=="8")
                              or (F[k]=="9")))
       {
@@ -6123,5 +6123,5 @@
       k=j+2;
       while (k<=size(F) and ((F[k]=="0") or (F[k]=="1") or (F[k]=="2") or (F[k]=="3") or
-                                (F[k]=="4") or (F[k]=="5") or (F[k]=="6") or (F[k]=="7") or (F[k]=="8") 
+                                (F[k]=="4") or (F[k]=="5") or (F[k]=="6") or (F[k]=="7") or (F[k]=="8")
                              or (F[k]=="9")))
       {
@@ -6136,10 +6136,10 @@
       F=stringdelete(F,j);
       j--;
-    }      
+    }
   }
   short=altshort;
   return(F);
 }
-  
+
 static proc texcoefficient (poly f,list #)
 "USAGE:      texcoefficient(f[,#]); f poly, # optional list
@@ -6176,5 +6176,5 @@
   }
   if (size(koeffizient)>5)
-  {    
+  {
     string tfractest=koeffizient[2..6];
     if (tfractest=="tfrac")
@@ -6259,5 +6259,5 @@
 static proc coordinatechange (poly f,intmat A,intvec v)
 "USAGE:   coordinatechange(f,A,v);  f poly, A intmat, v intvec
-ASSUME:   f is a polynomial in two variables, A is a 2x2 
+ASSUME:   f is a polynomial in two variables, A is a 2x2
           integer matrix, and v is an integer vector with 2 entries
 RETURN:   poly, the polynomial transformed by (x,y)->A*(x,y)+v
@@ -6280,5 +6280,5 @@
 ASSUME:      poly is a cubic polynomial
 RETURN:      poly, the Weierstrass normal form of the cubic, 0 if poly is not a cubic
-NOTE:        - the algorithm for the coefficients of the Weierstrass form is due to 
+NOTE:        - the algorithm for the coefficients of the Weierstrass form is due to
                Fernando Rodriguez Villegas, villegas@math.utexas.edu
              - if an additional argument # is given, the simplified Weierstrass form
@@ -6304,18 +6304,18 @@
   poly a4=((-3*t0*r0+s0^2)*q1+(-3*s1*s0*q0+s1*r0^2))*q3
     +(t0*r0*q2^2+(s1*s0*q1+((-3*t0*r2+s1^2)*q0+s0*r0*r2))*q2
-      +(t0*r2*q1^2+s1*r0*r2*q1+s0*r2^2*q0)); 
+      +(t0*r2*q1^2+s1*r0*r2*q1+s0*r2^2*q0));
   poly a6=(-27*t0^2*q0^2+(9*t0*s0*r0-s0^3)*q0-t0*r0^3)*q3^2+
-	(((9*t0^2*q0-t0*s0*r0)*q1+((-3*t0*s0*r1+(3*t0*s1*r0+
-	2*s1*s0^2))*q0+(t0*r0^2*r1-s1*s0*r0^2)))*q2+(-t0^2*q1^3
-	+(t0*s0*r1+(2*t0*s1*r0-s1*s0^2))*q1^2+((3*t0*s0*r2+
-	(-3*t0*s1*r1+2*s1^2*s0))*q0+((2*t0*r0^2-s0^2*r0)*r2+
-	(-t0*r0*r1^2+s1*s0*r0*r1-s1^2*r0^2)))*q1+((9*t0*s1*r2-
-	s1^3)*q0^2+(((-3*t0*r0+s0^2)*r1-s1*s0*r0)*r2+(t0*r1^3
-	-s1*s0*r1^2+s1^2*r0*r1))*q0)))*q3+(-t0^2*q0*q2^3+
-	(-t0*s1*r0*q1+((2*t0*s0*r2+(t0*s1*r1-s1^2*s0))*q0-
-	t0*r0^2*r2))*q2^2+(-t0*s0*r2*q1^2+(-t0*s1*r2*q0+
-	(t0*r0*r1-s1*s0*r0)*r2)*q1+((2*t0*r0-s0^2)*r2^2+
-	(-t0*r1^2+s1*s0*r1-s1^2*r0)*r2)*q0)*q2+
-	(-t0*r0*r2^2*q1^2+(t0*r1-s1*s0)*r2^2*q0*q1-
+        (((9*t0^2*q0-t0*s0*r0)*q1+((-3*t0*s0*r1+(3*t0*s1*r0+
+        2*s1*s0^2))*q0+(t0*r0^2*r1-s1*s0*r0^2)))*q2+(-t0^2*q1^3
+        +(t0*s0*r1+(2*t0*s1*r0-s1*s0^2))*q1^2+((3*t0*s0*r2+
+        (-3*t0*s1*r1+2*s1^2*s0))*q0+((2*t0*r0^2-s0^2*r0)*r2+
+        (-t0*r0*r1^2+s1*s0*r0*r1-s1^2*r0^2)))*q1+((9*t0*s1*r2-
+        s1^3)*q0^2+(((-3*t0*r0+s0^2)*r1-s1*s0*r0)*r2+(t0*r1^3
+        -s1*s0*r1^2+s1^2*r0*r1))*q0)))*q3+(-t0^2*q0*q2^3+
+        (-t0*s1*r0*q1+((2*t0*s0*r2+(t0*s1*r1-s1^2*s0))*q0-
+        t0*r0^2*r2))*q2^2+(-t0*s0*r2*q1^2+(-t0*s1*r2*q0+
+        (t0*r0*r1-s1*s0*r0)*r2)*q1+((2*t0*r0-s0^2)*r2^2+
+        (-t0*r1^2+s1*s0*r1-s1^2*r0)*r2)*q0)*q2+
+        (-t0*r0*r2^2*q1^2+(t0*r1-s1*s0)*r2^2*q0*q1-
      t0*r2^3*q0^2));
   poly b2=a1^2+4*a2;
@@ -6365,5 +6365,5 @@
              i.e. a polynomial of the form a+bx+cx2+dy+exy+fx2y+gy2+hxy2+ix2y2
 RETURN:      poly, a Weierstrass form of the elliptic curve defined by poly
-NOTE:        - the algorithm is based on the paper Sang Yook An, Seog Young Kim, 
+NOTE:        - the algorithm is based on the paper Sang Yook An, Seog Young Kim,
                David C. Marshall, Susan H. Marshall, William G. McCallum and Alexander R. Perlis:
                Jacobians of Genus One Curves. Journal of Number Theory 90,2 (2001), 304-315.
@@ -6388,5 +6388,5 @@
 
 static proc jInvariantOfACubic (poly f,list #)
-"USAGE:      jInvariantOfACubic(f[,#]); f poly, # list 
+"USAGE:      jInvariantOfACubic(f[,#]); f poly, # list
 ASSUME:      poly is a cubic polynomial defining an elliptic curve
 RETURN:      poly, the j-invariant of the elliptic curve defined by poly
@@ -6429,5 +6429,5 @@
 
 static proc jInvariantOfA2x2Curve (poly f,list #)
-"USAGE:      jInvariantOfA2x2Curve(f[,#]); f poly, # list 
+"USAGE:      jInvariantOfA2x2Curve(f[,#]); f poly, # list
 ASSUME:      poly, is a polynomial defining an elliptic curve of type (2,2) on P^1xP^1,
              i.e. a polynomial of the form a+bx+cx2+dy+exy+fx2y+gy2+hxy2+ix2y2
@@ -6475,5 +6475,5 @@
 
 static proc jInvariantOfA4x2Curve (poly f,list #)
-"USAGE:      jInvariantOfA4x2Curve(f[,#]); f poly, # list 
+"USAGE:      jInvariantOfA4x2Curve(f[,#]); f poly, # list
 ASSUME:      poly, is a polynomial defining an elliptic curve of type (4,2),
              i.e. a polynomial of the form a+bx+cx2+dx3+ex4+fy+gxy+hx2y+iy2
@@ -6515,7 +6515,7 @@
 
 static proc jInvariantOfAPuiseuxCubic (poly f,list #)
-"USAGE:      jInvariantOfAPuiseuxCubic(f[,#]); f poly, # list 
+"USAGE:      jInvariantOfAPuiseuxCubic(f[,#]); f poly, # list
 ASSUME:      poly is a cubic polynomial over Q(t) defining an elliptic curve and # is empty
-RETURN:      list, containing two polynomials whose ratio is the j-invariant of the 
+RETURN:      list, containing two polynomials whose ratio is the j-invariant of the
                    elliptic curve defined by poly
 ASSUME:      poly is a cubic polynomial over Q(t) defining an elliptic curve and # is non-empty
